Index: trunk/calendar/inc/class.bocalendar.inc.php
===================================================================
--- trunk/calendar/inc/class.bocalendar.inc.php	(revision 4935)
+++ trunk/calendar/inc/class.bocalendar.inc.php	(revision 5132)
@@ -97,6 +97,4 @@
 		);
 
-                var $wdays;
-
                 var $debug = False;
 //		var $debug = True;
@@ -111,9 +109,9 @@
 		var $year;
 		var $prefs;
-
+                var $wdays; 
 		var $owner;
 		var $holiday_color;
 		var $printer_friendly = False;
-
+                var $repetido;
 		var $cached_holidays;
 
@@ -142,4 +140,10 @@
        	var $async = false;
 
+                var $alreadyNotifieds;
+                var $alreadyExtNotifieds = array();
+                
+                var $extAdded;
+                var $extDeleted;
+                
 		function bocalendar($session=0)
 		{
@@ -300,5 +304,5 @@
 				MCAL_RECUR_DAILY	=> 'Daily',
 				MCAL_RECUR_WEEKLY	=> 'Weekly',
-            //MCAL_RECUR_MONTHLY_WDAY	=> 'Monthly (by day)',
+				MCAL_RECUR_MONTHLY_WDAY	=> 'Monthly (by day)',
 				MCAL_RECUR_MONTHLY_MDAY	=> 'Monthly (by date)',
 				MCAL_RECUR_YEARLY	=> 'Yearly'
@@ -382,37 +386,4 @@
                         $this->wdays = Array(MCAL_M_SUNDAY,MCAL_M_MONDAY,MCAL_M_TUESDAY,MCAL_M_WEDNESDAY,
                             MCAL_M_THURSDAY,MCAL_M_FRIDAY,MCAL_M_SATURDAY);
-		}
-
-		function delegar($idDelegador,$idDelegado,$idEvento) {
-
-			$this->so->cal->stream->lock(array("phpgw_cal_user"));
-			
-			if(substr($idDelegado,-1) == 'U') {
-			    $idDelegado = substr($idDelegado,0,-1);
-			}
-
-			$sql = "SELECT * FROM phpgw_cal_user where cal_id=$idEvento and cal_login=$idDelegado";
-
-			if($idDelegado != '')
-			{
-				$this->so->cal->stream->query($sql,__LINE__,__FILE__);
-				if($this->so->cal->stream->next_record())
-				{
-					throw new Exception("The selected User is already included in this event");
-				}else{
-					$sql = "update phpgw_cal_user set cal_login = $idDelegado,cal_status='U' where cal_id=$idEvento 
-						and cal_login=$idDelegador";
-
-					$this->so->cal->stream->query($sql,__LINE__,__FILE__,0,-1,true);
-				
-					$event = $this->so->read_entry($idEvento);
-
-					$this->send_update(MSG_ADDED,array($idDelegado => 'U'),$event,$event);
-				}
-			}else {
-				throw new Exception('999');
-			}
-
-			$this->so->cal->stream->unlock();
 		}
 
@@ -656,5 +627,5 @@
 //				print_debug('exception time',$event['recur_exception'][count($event['recur_exception']) -1]);
 //				print_debug('count event exceptions',count($event['recur_exception']));
-				$this->so->add_entry($event);
+				$this->so->add_entry($event,true,$event['owner']);
 				$cd = 16;
 
@@ -756,5 +727,5 @@
 				if($this->check_perms(PHPGW_ACL_DELETE,$event))
 				{
-					$this->send_update(MSG_DELETED,$event['participants'],$event);
+					$this->send_update(MSG_DELETED,$event['participants'],$event,false,$event['owner']);
 				}
 				else
@@ -815,11 +786,4 @@
                     $participants = $event['participants'];
 
-            //        $new_event = Array();
-            //        $new_event['owner'] = $owner;
-            //        $new_event['participants'] = $participants;
-            //        $new_event['start'] = $event['start'];
-            //        $new_event['end'] = $event['end'];
-            //
-            //        $return[] = $new_event;
 
                     switch($event['recur_type']) {
@@ -998,15 +962,8 @@
 		function update($params='')
 		{
+			$prefix = ( $params['from_mobile'] ? "mobile.ui_mobile" : "calendar.ui" ) . "calendar";
 			
-			if($params['from_mobile']) {
-				$ui_return = "mobile.ui_mobilecalendar.edit";
-				$ui_index = "mobile.ui_mobilecalendar.index";
-				$ui_overlap = "mobile.ui_mobilecalendar.overlap";
-			}
-			else {
-				$ui_return = "calendar.uicalendar.edit";
-				$ui_index = "calendar.uicalendar.index";		
-				$ui_overlap = "calendar.uicalendar.overlap";
-			}
+			$ui_return = "$prefix.edit";
+			$ui_index = "$prefix.index";
 			
 			if(!is_object($GLOBALS['phpgw']->datetime))
@@ -1014,41 +971,14 @@
 				$GLOBALS['phpgw']->datetime = createobject('phpgwapi.date_time');
 			}
-
 			$l_cal = (@isset($params['cal']) && $params['cal']?$params['cal']:$_POST['cal']);
-
-                        $post_max_size = ini_get('post_max_size');
-                        $mul = substr($post_max_size, -1);
-                        $mul = ($mul == 'M' ? 1048576 : ($mul == 'K' ? 1024 : ($mul == 'G' ? 1073741824 : 1)));
-                        if ($_SERVER['CONTENT_LENGTH'] > $mul*(int)$post_max_size && $post_max_size)
-                             $l_cal['attachment'] = 'ERROR';
-
-                        if(count($_FILES['cal']) > 0){
-
-                            if($l_cal['attachment'] != '')
-                               $attachments = unserialize($l_cal['attachment']);
-                            else
-                               $attachments = Array();
-
-                            foreach ($_FILES['cal']['error']['attachment'] as $key => $error) {
-
-                                if ($error == UPLOAD_ERR_OK) {
-
-                                    $new_file= $GLOBALS['phpgw_info']['server']['temp_dir'].'/'.$_SESSION[ 'phpgw_session' ][ 'session_id' ].md5($attachment['name'].microtime());
-                                    move_uploaded_file($_FILES['cal']['tmp_name']['attachment'][$key], $new_file);
-                                    $attach = Array('tmp_name' => $new_file, 'name' => $_FILES['cal']['name']['attachment'][$key], 'type' =>  $_FILES['cal']['type']['attachment'][$key]);
-
-                                    $attachments[] = $attach;
-
-                                }elseif($error == UPLOAD_ERR_INI_SIZE){
-                                    $attachments = 'ERROR';
-                                    break;
-
-                                }
-                            }
-                            $l_cal['attachment'] = $attachments;
-
-                        }
 			$l_participants = (@$params['participants']?$params['participants']:$_POST['participants']);
-			$this->ex_participants = (@$params['ex_participants']?$params['ex_participants']:$_POST['ex_participants']);
+
+                        require_once($_SESSION['rootPath'].'/calendar/inc/class.ex_participants.inc.php');
+                        $this->ex_participants = new exParticipants();
+                        $this->ex_participants->setParticipantsByString(@$params['ex_participants']?$params['ex_participants']:$_POST['ex_participants']);
+
+                        if(@$params['h_exParticipants']?$params['h_exParticipants']:$_POST['h_exParticipants'])
+                             $this->ex_participants->updateAttribBySerializable(@$params['h_exParticipants']?$params['h_exParticipants']:$_POST['h_exParticipants']);
+
 			$l_categories = (@$params['categories']?$params['categories']:$_POST['categories']);
 			$l_start = (@isset($params['start']) && $params['start']?$params['start']:$_POST['start']);
@@ -1083,5 +1013,5 @@
 					}
 				}
-				unset($l_cal['participants']);
+
 
 				if (!is_object($GLOBALS['phpgw']->categories))
@@ -1120,5 +1050,4 @@
 				$event['title'] = stripslashes($event['title']);
 				$event['description'] = stripslashes($event['description']);
-				$event['observations'] = stripslashes($event['observations']);
 				$event['ex_participants'] = stripslashes($event['ex_participants']);
 				$datetime_check = $this->validate_update($event);
@@ -1136,5 +1065,5 @@
 						return;
 				}
-				$overlapping_events = False;
+				//$overlapping_events = False;
 			}
 			else
@@ -1163,5 +1092,5 @@
 				if(!isset($l_cal['ex_participants']))
 				{
-					$l_cal['ex_participants'] = $this->ex_participants;
+					$l_cal['ex_participants'] = $this->ex_participants->getParticipantsSerializable();
 				}
 
@@ -1173,5 +1102,11 @@
 				$is_public = ($l_cal['type'] != 'private' && $l_cal['type'] != 'privateHiddenFields');
 				$this->so->event_init();
+
+                                if($l_cal['uid'])
 				$this->add_attribute('uid',$l_cal['uid']);
+                                else
+                                $this->add_attribute('uid',time().'@Expresso');
+                                
+
 				$this->add_attribute('type',$l_cal['type']);
 				if($l_cal['ex_participants']) {
@@ -1188,7 +1123,4 @@
 				$this->so->set_title($l_cal['title']);
 				$this->so->set_description($l_cal['description']);
-				$this->so->set_observations($l_cal['observations']);
-				$this->so->set_notifications_owner($l_cal['notifications_owner']);
-				$this->so->set_attachment($l_cal['attachment']);
 				$this->so->set_ex_participants($l_cal['ex_participants']);
 				$this->so->set_start($l_start['year'],$l_start['month'],$l_start['mday'],$l_start['hour'],$l_start['min'],0);
@@ -1197,8 +1129,4 @@
 				$this->so->add_attribute('reference',(@isset($l_cal['reference']) && $l_cal['reference']?$l_cal['reference']:0));
 				$this->so->add_attribute('location',(@isset($l_cal['location']) && $l_cal['location']?$l_cal['location']:''));
-				$this->so->add_attribute('repeat',(@isset($l_cal['recur_type']) && $l_cal['recur_type']?$l_cal['recur_type']:''));
-				$this->so->add_attribute('alarmd',(@isset($l_cal['alarmdays'])?$l_cal['alarmdays']:0));
-				$this->so->add_attribute('alarmh',(@isset($l_cal['alarmhours'])?$l_cal['alarmhours']:0));
-				$this->so->add_attribute('alarmm',(@isset($l_cal['alarmminutes'])?$l_cal['alarmminutes']:0));
 				if($l_cal['id'])
 				{
@@ -1222,7 +1150,5 @@
 						$this->so->set_recur_none();
 
-						$repetido = (int)$l_cal['recur_type']; // recebe o tipo de repeticao;
-						$this->so->add_attribute('recur_type',(@isset($repetido) && $repetido?$repetido:0));
-						$this->so->add_attribute('rpt_end_use',(@isset($l_cal['rpt_use_end']) && $l_cal['rpt_use_end']?$l_cal['rpt_use_end']:''));
+						$this->repetido = (int)$l_cal['recur_type']; // recebe o tipo de repeticao;
 
 						break;
@@ -1230,6 +1156,5 @@
 						$this->so->set_recur_daily((int)$l_recur_enddate['year'],(int)$l_recur_enddate['month'],(int)$l_recur_enddate['mday'],(int)$l_cal['recur_interval']);
 
-						$repetido = (int)$l_cal['recur_type']; // recebe o tipo de repeticao;
-						$this->so->add_attribute('recur_type',(@isset($repetido) && $repetido?$repetido:0));
+						$this->repetido = (int)$l_cal['recur_type']; // recebe o tipo de repeticao;
 
 						$tmp_init = explode("/",$_POST['start']['str']); // recebe a data inicial da repeticao;
@@ -1238,5 +1163,4 @@
 						if($l_cal['rpt_use_end'] == 'y') // verifica se foi indicada data final da repeticao, se sim:
 						{
-							$this->so->add_attribute('rpt_end_use',(@isset($l_cal['rpt_use_end']) && $l_cal['rpt_use_end']?$l_cal['rpt_use_end']:''));
 							
 							$tmp_end = explode("/",$_POST['recur_enddate']['str']); // recebe data final da repeticao;
@@ -1250,6 +1174,5 @@
 					case MCAL_RECUR_WEEKLY:
 
-						$repetido = (int)$l_cal['recur_type']; // recebe o tipo de repeticao;
-						$this->so->add_attribute('recur_type',(@isset($repetido) && $repetido?$repetido:0));
+						$this->repetido = (int)$l_cal['recur_type']; // recebe o tipo de repeticao;
 
 						$tmp_init = explode("/",$_POST['start']['str']); // recebe a data inicial da repeticao;
@@ -1259,5 +1182,4 @@
 						{
 
-							$this->so->add_attribute('rpt_end_use',(@isset($l_cal['rpt_use_end']) && $l_cal['rpt_use_end']?$l_cal['rpt_use_end']:''));
 							$tmp_end = explode("/",$_POST['recur_enddate']['str']); // recebe data final da repeticao;
 							$end_rept = mktime($_POST['start']['hour'],$_POST['start']['min'],0,intval($tmp_end[1]),$tmp_end[0],$tmp_end[2]); // transforma a data inicial + hora e minuto de inicio da repeticao em UNIX timestamp;
@@ -1280,5 +1202,4 @@
 							}
 						}
-						$this->so->add_attribute('rpt_wdays',(@isset($rpt_wdays) && $rpt_wdays?$rpt_wdays:''));
 						$this->so->set_recur_weekly((int)$l_recur_enddate['year'],(int)$l_recur_enddate['month'],(int)$l_recur_enddate['mday'],(int)$l_cal['recur_interval'],$l_cal['recur_data']);
 						break;
@@ -1286,6 +1207,5 @@
 						$this->so->set_recur_monthly_mday((int)$l_recur_enddate['year'],(int)$l_recur_enddate['month'],(int)$l_recur_enddate['mday'],(int)$l_cal['recur_interval']);
 
-						$repetido = (int)$l_cal['recur_type']; // recebe o tipo de repeticao;
-						$this->so->add_attribute('recur_type',(@isset($repetido) && $repetido?$repetido:0));
+						$this->repetido = (int)$l_cal['recur_type']; // recebe o tipo de repeticao;
 
 						$tmp_init = explode("/",$_POST['start']['str']); // recebe a data inicial da repeticao;
@@ -1294,5 +1214,5 @@
 						if($l_cal['rpt_use_end'] == 'y') // verifica se foi indicada data final da repeticao, se sim:
 						{
-							$this->so->add_attribute('rpt_end_use',(@isset($l_cal['rpt_use_end']) && $l_cal['rpt_use_end']?$l_cal['rpt_use_end']:''));
+
 							$tmp_end = explode("/",$_POST['recur_enddate']['str']); // recebe data final da repeticao;
 							$end_rept = mktime($_POST['start']['hour'],$_POST['start']['min'],0,intval($tmp_end[1]),$tmp_end[0],$tmp_end[2]); // transforma a data inicial + hora e minuto de inicio da repeticao em UNIX timestamp;
@@ -1309,6 +1229,5 @@
 						$this->so->set_recur_yearly((int)$l_recur_enddate['year'],(int)$l_recur_enddate['month'],(int)$l_recur_enddate['mday'],(int)$l_cal['recur_interval']);
 
-						$repetido = (int)$l_cal['recur_type']; // recebe o tipo de repeticao;
-						$this->so->add_attribute('recur_type',(@isset($repetido) && $repetido?$repetido:0));
+						$this->repetido = (int)$l_cal['recur_type']; // recebe o tipo de repeticao;
 
 						$tmp_init = explode("/",$_POST['start']['str']); // recebe a data inicial da repeticao;
@@ -1317,5 +1236,5 @@
 						if($l_cal['rpt_use_end'] == 'y') // verifica se foi indicada data final da repeticao, se sim:
 						{
-							$this->so->add_attribute('rpt_end_use',(@isset($l_cal['rpt_use_end']) && $l_cal['rpt_use_end']?$l_cal['rpt_use_end']:''));
+
 							$tmp_end = explode("/",$_POST['recur_enddate']['str']); // recebe data final da repeticao;
 							$end_rept = mktime($_POST['start']['hour'],$_POST['start']['min'],0,intval($tmp_end[1]),$tmp_end[0],$tmp_end[2]); // transforma a data inicial + hora e minuto de inicio da repeticao em UNIX timestamp;
@@ -1340,5 +1259,5 @@
 						}
 						$acct_type = $GLOBALS['phpgw']->accounts->get_type((int)$parts[$i]);
-						if($acct_type == 'u')
+						if($acct_type == 'u' || $acct_type == 's')
 						{
 							$part[(int)$parts[$i]] = $accept_type;
@@ -1422,6 +1341,5 @@
 				$event = $this->get_cached_event();
 
-				if ($l_cal['alarmdays'] > 0 || $l_cal['alarmhours'] > 0 ||
-						$l_cal['alarmminutes'] > 0)
+				if ($l_cal['alarmdays'] > 0 || $l_cal['alarmhours'] > 0 ||$l_cal['alarmminutes'] > 0)
 				{
 					$offset = ($l_cal['alarmdays'] * 24 * 3600) +
@@ -1435,5 +1353,5 @@
 						'owner'   => $this->owner,
 						'enabled' => 1,
-						'repeat'  => $repetido, // para repetir alarme;
+						'repeat'  => $this->repetido, // para repetir alarme;
 						'init_rept' => $init_rept, // inicio repeticao;
 						'end_rept' => $end_rept, // fim repeticao;
@@ -1463,4 +1381,96 @@
 				}
 
+			    $overlapping_events = $this->event_overlap( $event, $send_to_ui, $prefix );
+
+			    if( $overlapping_events )
+				return( $overlapping_events );
+			}
+
+				$event['ex_participants'] = $this->ex_participants->getParticipantsSerializable();
+			
+                        if($event['owner'] != $GLOBALS['phpgw_info']['user']['account_id']) $userSend = $event['owner'];
+                        else $userSend = false;
+       
+			if(!$event['id'])
+			{
+                                /** Whenever a recurrent event is edit in a way that a new  
+                                 * exception is created, an exception must be added to 
+                                 * the old event. This is necessary to keep consistency 
+                                 * with synchornization solutions in accordancy to 
+                                 * the iCalendar RFC. 
+                                 */ 
+                                $old_event = $this->so->read_entry($_POST['cal']['reference']); 
+
+                                $date = $_POST['cal']['date']; 
+                                $year  = substr($date,0,4); 
+                                $month = substr($date,4,2); 
+                                $day   = substr($date,6,2); 
+
+                                $exception_time = mktime($old_event['start']['hour'],$old_event['start']['min'],0,$month,$day,$year) - $GLOBALS['phpgw']->datetime->tz_offset; 
+                                $old_event['recur_exception'][] = (int)$exception_time; 
+                                $this->so->add_entry($old_event,false); 
+                            
+                            
+                                $this->so->add_entry($event,false);
+				print_debug('New Event ID',$event['id']);
+                                $send_type = MSG_ADDED;
+			}
+			else
+			{
+				print_debug('Updating Event ID',$event['id']);
+				$new_event = $event;
+				$old_event = $this->read_entry($event['id']);
+				// if old event has alarm and the start-time changed => update them
+				//echo "<p>checking ".count($old_event['alarm'])." alarms of event #$event[id] start moved from ".print_r($old_event['start'],True)." to ".print_r($event['start'],True)."</p>\n";
+				if ($old_event['alarm'] &&
+					$this->maketime($old_event['start']) != $this->maketime($event['start']))
+				{
+					$this->so->delete_alarms($old_event['id']);
+					foreach($old_event['alarm'] as $id => $alarm)
+					{
+						$alarm['time'] = $this->maketime($event['start']) - $alarm['offset'];
+						$event['alarm'][] = $alarm;
+					}
+					//echo "updated alarms<pre>".print_r($event['alarm'],True)."</pre>\n";
+				}
+				$this->so->cal->event = $event;
+				$this->so->add_entry($event,false);
+				$this->prepare_recipients($new_event,$old_event,$userSend);
+                                $send_type = MSG_MODIFIED;
+			}
+                     
+                        //Retira da lista usuarios ja notificados
+                        $to_notify = $event['participants'];
+                        foreach ($this->alreadyNotifieds as $key => $value) 
+                            if(array_key_exists($value,$to_notify))
+                                unset ($to_notify[$value]);
+                        //------------------------------------------------//
+                           
+                        if(count($to_notify) > 0 && $userSend !== -2)    
+                            $this->send_update( $send_type,$to_notify,'',$this->get_cached_event(),$userSend);
+
+			$date = sprintf("%04d%02d%02d",$event['start']['year'],$event['start']['month'],$event['start']['mday']);
+			if($send_to_ui)
+			{
+				$this->read_sessiondata();
+				if ($this->return_to)
+				{
+					$GLOBALS['phpgw']->redirect_link('/index.php','menuaction='.$this->return_to);
+					$GLOBALS['phpgw']->common->phpgw_exit();
+				}
+				Execmethod($ui_index);
+			}
+			else
+			{
+				return (int)$event['id'];
+			}
+
+			return True;
+		}
+
+		function event_overlap( $event, $send_to_ui = false, $prefix = "calendar.uicalendar" ,$user = false)
+		{
+		    $event_ids = array();
+
 				if($event['id'])
 				{
@@ -1472,5 +1482,6 @@
 				}
 
-				if (isset($repetido) and $repetido > 0){
+                    if (isset($this->repetido) and $this->repetido > 0)
+                    { 
                                     $events = $this->expand_repetition($event);
                                     $overlapping_events = False;
@@ -1492,5 +1503,6 @@
                                     }
                                 }
-                                else {
+                    else 
+                    { 
                                     $overlapping_events = $this->overlap(
                                         $this->maketime($event['start']),
@@ -1501,78 +1513,28 @@
                                     );
                                 }
-			}
-			if(!$this->ex_participants)
-				$this->ex_participants = $event['ex_participants'];			
+                                      
 			if($overlapping_events)
 			{
+                            $this->store_to_appsession( $event );
 				if($send_to_ui)
 				{
-					$event['ex_participants'] = $this->ex_participants;
 					unset($GLOBALS['phpgw_info']['flags']['noheader']);
 					unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
-					ExecMethod($ui_overlap,
+				    ExecMethod("$prefix.overlap",
 						Array(
 							'o_events'	=> $overlapping_events,
-							'this_event'	=> $event
+						    'this_event'	=> $event,
+                                                    'this_account' => $user
 						)
 					);
-					if(!$params['from_mobile'])
+
+				    if( $prefix === "calendar.uicalendar" )
 						$GLOBALS['phpgw']->common->phpgw_exit(True);
-					else
-						return;
-				}
-				else
-				{
-					return $overlapping_events;
-				}
-			}
-			else
-			{
-				if(!$event['id'])
-				{
-					$this->so->add_entry($event);
-					$this->send_update(MSG_ADDED,$event['participants'],'',$this->get_cached_event());
-					print_debug('New Event ID',$event['id']);
-				}
-				else
-				{
-					print_debug('Updating Event ID',$event['id']);
-					$new_event = $event;
-					$old_event = $this->read_entry($event['id']);
-					// if old event has alarm and the start-time changed => update them
-					//echo "<p>checking ".count($old_event['alarm'])." alarms of event #$event[id] start moved from ".print_r($old_event['start'],True)." to ".print_r($event['start'],True)."</p>\n";
-					if ($old_event['alarm'] &&
-						$this->maketime($old_event['start']) != $this->maketime($event['start']))
-					{
-						$this->so->delete_alarms($old_event['id']);
-						foreach($old_event['alarm'] as $id => $alarm)
-						{
-							$alarm['time'] = $this->maketime($event['start']) - $alarm['offset'];
-							$event['alarm'][] = $alarm;
-						}
-						//echo "updated alarms<pre>".print_r($event['alarm'],True)."</pre>\n";
-					}
-					$this->so->cal->event = $event;
-					$this->so->add_entry($event);
-					$this->prepare_recipients($new_event,$old_event);
-				}
-
-				$date = sprintf("%04d%02d%02d",$event['start']['year'],$event['start']['month'],$event['start']['mday']);
-				if($send_to_ui)
-				{
-					$this->read_sessiondata();
-					if ($this->return_to)
-					{
-						$GLOBALS['phpgw']->redirect_link('/index.php','menuaction='.$this->return_to);
-						$GLOBALS['phpgw']->common->phpgw_exit();
-					}
-					Execmethod($ui_index);
-				}
-				else
-				{
-					return (int)$event['id'];
-				}
-			}
-			return True;
+				}
+
+			    return( $overlapping_events );
+			}
+
+		    return( false );
 		}
 
@@ -1700,57 +1662,13 @@
 				$error = 43;
 			}
-			elseif ($event['type'] != 'hourAppointment' && $event['title'] == '')
+			elseif ($event['title'] == '')
 			{
 				$error = 40;
 			}
-			elseif ($event['repeat'] != 0)
-			{
-				if( $event['rpt_end_use'] != 'y')
-				{
-					$error = 46;
-				}
-			//}
-			  if ($event['repeat'] == 2)
-			  {
-    				if($event['rpt_wdays'] == '') {
-        				$error = 44;
-            			}
-				if( $event['rpt_end_use'] != 'y')
-				{
-					$error = 46;
-				}
-
-                    		if (  ( isset($event['alarmd'])  && ($event['alarmd'] != 0) ) || ( isset($event['alarmh'])  && ($event['alarmh'] != 0) ) || ( isset($event['alarmm'])  && ($event['alarmm'] != 0) ) )
-                    		{
-		                    	if( isset($event['recur_type']) && ($event['recur_type'] != 0) )
-                    			{
-		                    		if( $event['rpt_end_use'] != 'y')
-	                    			{
-		                    			$error = 45;
-                		    		}
-                    			}
-                    		}
-			   }
-
-			//}
-		  if (  ( isset($event['alarmd'])  && ($event['alarmd'] != 0) ) || ( isset($event['alarmh'])  && ($event['alarmh'] != 0) ) || ( isset($event['alarmm'])  && ($event['alarmm'] != 0) ) )
-                  {
-                	if( isset($event['recur_type']) && ($event['recur_type'] != 0) )
-                	{
-                		if( $event['rpt_end_use'] != 'y')
-                		{
-                			$error = 45;
-                		}
-                	}
-                  }
-		}
 			elseif (($GLOBALS['phpgw']->datetime->time_valid($event['start']['hour'],$event['start']['min'],0) == False) || ($GLOBALS['phpgw']->datetime->time_valid($event['end']['hour'],$event['end']['min'],0) == False))
 			{
 				$error = 41;
 			}
-			elseif (($GLOBALS['phpgw']->datetime->date_valid($event['start']['year'],$event['start']['month'],$event['start']['mday']) == False) 
-				|| ($GLOBALS['phpgw']->datetime->date_valid($event['end']['year'],$event['end']['month'],$event['end']['mday']) == False)
-				|| ($GLOBALS['phpgw']->datetime->date_compare($event['start']['year'],$event['start']['month'],$event['start']['mday'],$event['end']['year'],$event['end']['month'],$event['end']['mday']) == 1)
-				|| $event['start']['year'] > 2037 || $event['end']['year'] > 2037)
+			elseif (($GLOBALS['phpgw']->datetime->date_valid($event['start']['year'],$event['start']['month'],$event['start']['mday']) == False) || ($GLOBALS['phpgw']->datetime->date_valid($event['end']['year'],$event['end']['month'],$event['end']['mday']) == False) || ($GLOBALS['phpgw']->datetime->date_compare($event['start']['year'],$event['start']['month'],$event['start']['mday'],$event['end']['year'],$event['end']['month'],$event['end']['mday']) == 1))
 			{
 				$error = 42;
@@ -1758,12 +1676,9 @@
 			elseif ($GLOBALS['phpgw']->datetime->date_compare($event['start']['year'],$event['start']['month'],$event['start']['mday'],$event['end']['year'],$event['end']['month'],$event['end']['mday']) == 0)
 			{
-				if ( ($GLOBALS['phpgw']->datetime->time_compare($event['start']['hour'],$event['start']['min'],0,$event['end']['hour'],$event['end']['min'],0) == 1)
-                                   ||($GLOBALS['phpgw']->datetime->time_compare($event['start']['hour'],$event['start']['min'],0,$event['end']['hour'],$event['end']['min'],0) == 0) )
-				{
-					$error = 47;
-				}
-			}
-                        if($event['attachment'] == 'ERROR')
-                            $error = 99;
+				if ($GLOBALS['phpgw']->datetime->time_compare($event['start']['hour'],$event['start']['min'],0,$event['end']['hour'],$event['end']['min'],0) == 1)
+				{
+					$error = 42;
+				}
+			}
                         
 			return $error;
@@ -1789,16 +1704,4 @@
 		}
 		
-		function participants_unanswered($participants,$event)
-		{
-			foreach($participants as $uid => $status)
-			{				
-				if (isset($event['participants'][$uid]) && $event['participants'][$uid] == 'U' && $status == 'U')
-				{
-					return False;
-				}
-			}
-			return True;
-		}
-
 		function overlap($starttime,$endtime,$participants,$owner=0,$id=0,$restore_cache=False)
 		{
@@ -1909,5 +1812,5 @@
 								$temp_start_time >= $temp_event_start &&
 								$temp_end_time <= $temp_event_end) &&
-								$this->participants_not_rejected($participants,$event) && $this->participants_unanswered($participants,$event))
+								$this->participants_not_rejected($participants,$event))
 							{
 								if($this->debug)
@@ -2080,5 +1983,9 @@
 		function get_short_field($event,$is_private=True,$field='')
 		{
-			if($is_private)
+			if($is_private && $event['type'] == 'E')
+			{
+				return lang('Restrict');
+			}
+			else if($is_private && $event['type'] == 'P')
 			{
 				return lang('private');
@@ -2342,5 +2249,5 @@
 			$search_date_day = date('d',$datetime);
 			$search_date_dow = date('w',$datetime);
-			$search_beg_day = mktime(12,0,0,$search_date_month,$search_date_day,$search_date_year);
+			$search_beg_day = mktime(0,0,0,$search_date_month,$search_date_day,$search_date_year);
 			if($this->debug)
 			{
@@ -2409,5 +2316,5 @@
 							break;
 						case MCAL_RECUR_WEEKLY:
-							if (floor(($search_beg_day - $event_beg_day)/604800)  % ($freq ? $freq : 1))
+							if ((floor($search_beg_day / 604800) - floor($event_beg_day / 604800)) % $freq)
 							{
 								continue;
@@ -2934,5 +2841,5 @@
 		@abstract set the participant response $status for event $cal_id and notifies the owner of the event
 		*/
-		function set_status($cal_id,$status)
+		function set_status($cal_id,$status,$user = false)
 		{
 			$status2msg = array(
@@ -2946,13 +2853,24 @@
 			}
 			$event = $this->so->read_entry($cal_id);
-			$account_id = $GLOBALS['phpgw_info']['user']['account_id'];
+                        if($user) $account_id = $user;
+                        else $account_id = $GLOBALS['phpgw_info']['user']['account_id'];
 			if(($status2msg[$status] == "5" && $event['participants'][$account_id] == "A") ||
 			 ($status2msg[$status] == "3" && $event['participants'][$account_id] == "R")) {
 				return True;
 			}
-			$this->so->set_status($cal_id,$status);
+			$this->so->set_status($cal_id,$status,$account_id);
 			$event = $this->so->read_entry($cal_id);
-			$this->send_update($status2msg[$status],$event['participants'],$event);
-
+			$this->send_update($status2msg[$status],$event['participants'],$event,false,$account_id);
+
+			$sts = array_values( $event['participants'] );
+
+			//verifica se todos os participantes rejeitaram o evento
+			while( $sts[0] && $sts[0] === 'R' ) array_pop( $sts );
+
+			if( empty( $sts ) )
+			{
+				$this->so->delete_entry( $cal_id );
+				$this->so->expunge();
+			}
 		}
 
